/* 
 * Copyright (c) 2000 Carnegie Mellon University.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. The name "Carnegie Mellon University" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For permission or any other legal
 *    details, please contact  
 *      Office of Technology Transfer
 *      Carnegie Mellon University
 *      5000 Forbes Avenue
 *      Pittsburgh, PA  15213-3890
 *      (412) 268-4387, fax: (412) 268-7395
 *      tech-transfer@andrew.cmu.edu
 *
 * 4. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by Computing Services
 *     at Carnegie Mellon University (http://www.cmu.edu/computing/)."
 *
 * CARNEGIE MELLON UNIVERSITY DISCLAIMS ALL WARRANTIES WITH REGARD TO
 * THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
 * AND FITNESS, IN NO EVENT SHALL CARNEGIE MELLON UNIVERSITY BE LIABLE
 * FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN
 * AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING
 * OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/*
 * mac mail facilities used by all .c files
 */

#include <setjmp.h>

#include "common.h"

#define FAIL_NET(xx_call,xx_arg) \
	{if((fail_io=(xx_call))<0)io_rl_error xx_arg;}
extern int fail_io;

extern int rl_chunk_size;
extern int half_buf;

/*  global fatal error catch */

#define MAX_CATCH 10

struct t_catch_rl_R {
  jmp_buf catch[MAX_CATCH];
  int inuse;/*non zero if catch buffer is currently active*/
};
typedef struct t_catch_rl_R t_catch_rl;
extern t_catch_rl catch_rl; /*errors throw to here*/

#define IF_NET_CATCH

    /*set_rl_catch(); \
    if(setjmp(&catch_rl.catch[catch_rl.inuse-1])!=0)*/

#define IF_NET_DEAD 


/*	{if(is_net_dead() || \
	      set_rl_catch() || \
	      (setjmp(&catch_rl.catch[catch_rl.inuse-1])!=0))*/

#define END_CATCH

	    /* {clear_rl_catch();} } */

